 
// Fenster: Taster hintere Stuetzen um 5 nach oben gesetzt.
// Wassertank gleich beim einschalten prüfen



#include <EEPROM.h>
#include <UTFT.h>
#include <OneWire.h>
#include <DallasTemperature.h>
#include <UTouch.h>
#include <UTFT_Buttons.h>
#include <Wire.h>
#include <avr/pgmspace.h>




void Buttons_Stuetzen();
void display_stuetzen();
void Stuetzen();
void Strom_kalibrieren();
void Strom_Motoren();
void Stuetzen_runter_automatik();
void Stuetzen_rauf_automatik();

void Manuell();
void adresseAusgeben(void);

//
// Deklaration der verwendeten Schriften
//
extern uint8_t SmallFont[];
extern uint8_t BigFont[];
extern uint8_t DotMatrix_M[];
extern uint8_t arial_normal[];
extern uint8_t Sinclair_S[];
extern uint8_t Inconsola[];
extern uint8_t Ubuntu[];
extern uint8_t UbuntuBold[];
extern uint8_t arial_bold[];
// Bitmaps

extern uint16_t refrigerator[];
extern uint16_t auf[];
extern uint16_t ab[];
extern uint16_t auf_auto[];
extern uint16_t ab_auto[];
extern uint16_t no[];
extern uint16_t Fan[];
extern uint16_t wasser[];
extern uint16_t solar[];

extern uint16_t einstellungen[];
extern uint16_t home[];


extern uint16_t battery[];
//
// Initialisierung des Displays
//


//UTFT          myGLCD(TFT01_32, 38, 39, 40, 41);
UTFT          myGLCD(SSD1289, 38, 39, 40, 41);//xxx
//UTFT          myGLCD(ITDB32S, 38, 39, 40, 41);
UTouch        myTouch(6, 5, 4, 3, 2);
UTFT_Buttons  myButtons(&myGLCD, &myTouch);


//
// Initialisierung der Variablen
//
#define TASKdauer_ms  100
#define taskStrom 10
#define taskDisplay 60
#define TASK1s  50
#define TASK100ms  30



#define taskflagclear 0
#define task100msflag 1
#define taskStromflag 2
#define taskDisplayflag 3
#define taskSensorenflag 4
#define task1sflag 5


#define PIN_Motor_li_vo_runter 8
#define PIN_Motor_li_vo_rauf 9
#define PIN_Motor_re_vo_runter 10
#define PIN_Motor_re_vo_rauf 11
#define PIN_Motor_li_hi_runter 12
#define PIN_Motor_li_hi_rauf 14
#define PIN_Motor_re_hi_runter 15
#define PIN_Motor_re_hi_rauf 16

#define ADC_Solar_Strom A0
#define ADC_Motor_li_vo A1
#define ADC_Motor_re_vo A2
#define ADC_Motor_li_hi A3
#define ADC_Motor_re_hi A4
#define ADC_Batterie_Spannung A5


#define Endschalter_li_vo ((PINK &(1 << PINK4))) //A12
#define Endschalter_re_vo ((PINK &(1 << PINK5))) //A13
#define Endschalter_li_hi ((PINK &(1 << PINK6))) //A14
#define Endschalter_re_hi ((PINK &(1 << PINK7))) //A15


#define PIN_Freigabe 42
#define PIN_Taster_rauf 43
#define PIN_Taster_runter 45
#define PIN_Ventilator   49

#define Taster_Freigabe (digitalRead(PIN_Freigabe))
#define Taster_rauf (!(digitalRead(PIN_Taster_rauf)))
#define Taster_runter (!(digitalRead(PIN_Taster_runter)))


#define Motor_li_vo_rauf  {digitalWrite(PIN_Motor_li_vo_runter,HIGH);digitalWrite(PIN_Motor_li_vo_rauf, LOW);}
#define Motor_li_vo_runter   {digitalWrite(PIN_Motor_li_vo_runter,LOW);digitalWrite(PIN_Motor_li_vo_rauf, HIGH);}
#define Motor_li_vo_stopp    {digitalWrite(PIN_Motor_li_vo_runter,HIGH);digitalWrite(PIN_Motor_li_vo_rauf, HIGH);}

#define Motor_re_vo_rauf  {digitalWrite(PIN_Motor_re_vo_runter,HIGH);digitalWrite(PIN_Motor_re_vo_rauf, LOW);}
#define Motor_re_vo_runter    {digitalWrite(PIN_Motor_re_vo_runter,LOW);digitalWrite(PIN_Motor_re_vo_rauf, HIGH);}
#define Motor_re_vo_stopp    {digitalWrite(PIN_Motor_re_vo_runter,HIGH);digitalWrite(PIN_Motor_re_vo_rauf, HIGH);}

#define Motor_li_hi_rauf  {digitalWrite(PIN_Motor_li_hi_runter,HIGH);digitalWrite(PIN_Motor_li_hi_rauf, LOW);}
#define Motor_li_hi_runter    {digitalWrite(PIN_Motor_li_hi_runter,LOW);digitalWrite(PIN_Motor_li_hi_rauf, HIGH);}
#define Motor_li_hi_stopp    {digitalWrite(PIN_Motor_li_hi_runter,HIGH);digitalWrite(PIN_Motor_li_hi_rauf, HIGH);}

#define Motor_re_hi_rauf  {digitalWrite(PIN_Motor_re_hi_runter,HIGH);digitalWrite(PIN_Motor_re_hi_rauf, LOW);}
#define Motor_re_hi_runter    {digitalWrite(PIN_Motor_re_hi_runter,LOW);digitalWrite(PIN_Motor_re_hi_rauf, HIGH);}
#define Motor_re_hi_stopp    {digitalWrite(PIN_Motor_re_hi_runter,HIGH);digitalWrite(PIN_Motor_re_hi_rauf, HIGH);}



#define Ventilator_ein    {digitalWrite(PIN_Ventilator, HIGH);}
#define Ventilator_aus    {digitalWrite(PIN_Ventilator, LOW);}

#define dimmer_hell 25
#define dimmer_abgedunkelt 210
#define dimmer_fastdunkel 235
#define dimmer_dunkel 255

#define Intervall_Wassermessung 30 //Sekunden

#define Case_Anzeige 1
#define Case_stuetzen 2
#define Case_einstell 3


#define Batterie_Blei 1
#define Batterie_LiFePo4 2

#define Endschalter_vorhanden 1
#define Endschalter_nicht_vorhanden 2


#define Status_warten 0
#define Status_start 1
#define Status_normal 2
#define Status_Endposition 8
#define Status_Fehler 99
//#define Erkennung_Endposition 5

  int wasserstand;
  float EisTemp;
  float KTemp; 
  float LTemp; // Lüfter Temperatur


long Strom_Motor_li_vo, Strom_Motor_re_vo, Strom_Motor_li_hi, Strom_Motor_re_hi;
float Strom_Solar, Spannung_Batterie, Spannung_Kalibrierung;
long Strom_kalib_Motor_li_vo, Strom_kalib_Motor_re_vo, Strom_kalib_Motor_li_hi, Strom_kalib_Motor_re_hi;
char status_m_l_v, status_m_r_v, status_m_l_h, status_m_r_h;
char buffer[20];
short status_luefter,status_luefter_alt,status_luefter_aktuell,status_batterie,status_batterie_alt;   
int dallas_sensor_counter;
unsigned char dimmer;
unsigned short sekunden,sekunde_wasser;
char Case;
unsigned short temp_wasser0,temp_wasser1,temp_wasser2,temp_wasser3;

char soll_EisTemp, sollKtemp, soll_k_luefter,soll_h_luefter,Batterietyp,Endschalter,soll_Timeout_Endpostion;
char  soll_Strom_blockiert, soll_Strom_Endposition, soll_Strom_normal,soll_Solar,soll_Wasserstand;


#define ONE_WIRE_BUS 17               //Pin 17 als OneWire 
OneWire ourWire(ONE_WIRE_BUS);        /* Ini oneWire instance */
DallasTemperature sensors(&ourWire);  



int Taste_li_vor_rauf = 	myButtons.addButton(10, 15, 60, 40, auf);
int Taste_li_vor_runter = 	myButtons.addButton(10, 70, 60, 40, ab);

int Taste_re_vor_rauf = 	myButtons.addButton(170, 15, 60, 40, auf);
int Taste_re_vor_runter = 	myButtons.addButton(170, 70, 60, 40, ab);

int Taste_li_hi_rauf = 		myButtons.addButton(10, 135, 60, 40, auf);
int Taste_li_hi_runter = 	myButtons.addButton(10, 190, 60, 40, ab);

int Taste_re_hi_rauf = 		myButtons.addButton(170, 135, 60, 40, auf);
int Taste_re_hi_runter = 	myButtons.addButton(170, 190, 60, 40, ab);

int Taste_Auto_rauf = 		myButtons.addButton(100, 40, 50, 50, auf_auto);
int Taste_stopp =  			myButtons.addButton(95, 90, 60, 60, no);
int Taste_Auto_runter = 	myButtons.addButton(100, 160, 50, 50, ab_auto);


int Taste_Manuell =  		myButtons.addButton(250, 80, 65, 37, "Manuell");
int Taste_fertig =  		myButtons.addButton(250, 130, 65, 37, "Fertig");


int Taste_Stuetzen = 		myButtons.addButton(244, 183, 70, 37, "Stuetzen");
//int Taste_Anzeige = 		myButtons.addButton(250, 183, 65, 37, "Anzeige");
int Taste_Anzeige =     myButtons.addButton(265, 183, 32, 32, home);

int Taste_Vent =        myButtons.addButton(15, 180, 34, 34, Fan);
//int Taste_Einstell =    myButtons.addButton(164, 185, 70, 37, "Einstell");
int Taste_Einstell =    myButtons.addButton(180, 183, 32, 32, einstellungen);
int Taste_n_Funktion  = myButtons.addButton(170, 10, 140, 37, "naechste Funktion");
int Taste_Ok          = myButtons.addButton(190, 60, 100, 37, "Ok Speichern");
int Taste_Aendern     = myButtons.addButton(190, 60, 100, 37, "Aendern");
int Taste_gedrueckt;


volatile int taskflag,taskflagS;
volatile unsigned short timeout;
/*****************************************************************************************************************************************/
void setup()
{
  analogWrite(13, dimmer_fastdunkel);
_delay_ms(10);
  /*+++++++Timer4++++++++++++++++*/
  TCCR4A = 0; //CTC Mode
  TCCR4B = (1 << CS41) | (1 << CS40) | (1 << WGM42); // Prescaler 64
  TIMSK4 = (1 << OCIE4A); //Interupt compare match enable
  OCR4A = 249; // alle 1ms 1 Interrupt

  pinMode(PIN_Motor_li_vo_runter, OUTPUT);
  pinMode(PIN_Motor_li_vo_rauf, OUTPUT);
  pinMode(PIN_Motor_re_vo_runter, OUTPUT);
  pinMode(PIN_Motor_re_vo_rauf, OUTPUT);
  pinMode(PIN_Motor_li_hi_runter, OUTPUT);
  pinMode(PIN_Motor_li_hi_rauf, OUTPUT);
  pinMode(PIN_Motor_re_hi_runter, OUTPUT);
  pinMode(PIN_Motor_re_hi_rauf, OUTPUT);

  pinMode(PIN_Ventilator, OUTPUT);
  
  pinMode(PIN_Freigabe, INPUT);
  pinMode(PIN_Taster_rauf, INPUT_PULLUP);
  pinMode(PIN_Taster_runter, INPUT_PULLUP);

  pinMode(ADC_Batterie_Spannung, INPUT);
  
/*
  digitalWrite(PIN_Motor_li_vo_runter, LOW);
  digitalWrite(PIN_Motor_li_vo_rauf, LOW);
  digitalWrite(PIN_Motor_re_vo_runter, LOW);
  digitalWrite(PIN_Motor_re_vo_rauf, LOW);
  digitalWrite(PIN_Motor_li_hi_runter, LOW);
  digitalWrite(PIN_Motor_li_hi_rauf, LOW);
  digitalWrite(PIN_Motor_re_hi_runter, LOW);
  digitalWrite(PIN_Motor_re_hi_rauf, LOW);
*/
    Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;

  /* Eingang mit Pullup*/
  /* Endschalter */
  DDRK &= ~(1 << DDK4); PORTK |= (1<<DDK4);
  DDRK &= ~(1 << DDK5); PORTK |= (1<<DDK5);
  DDRK &= ~(1 << DDK6); PORTK |= (1<<DDK6);
  DDRK &= ~(1 << DDK7); PORTK |= (1<<DDK7);



  myGLCD.InitLCD(LANDSCAPE);
  _delay_ms(5);
  myGLCD.setFont(Sinclair_S);
  _delay_ms(2);
  myTouch.InitTouch();
  _delay_ms(5);
  myTouch.setPrecision(PREC_MEDIUM);
  _delay_ms(2);
  myButtons.setTextFont(Sinclair_S);
  myButtons.setButtonColors(VGA_WHITE, VGA_GRAY, VGA_WHITE, VGA_RED, VGA_BLUE);

  _delay_ms(5);
  
  sensors.begin();                    // Inizialisieren der Dallas Temperature library
  analogReference(DEFAULT);
  sensors.setResolution(10);  // Temperatursensoren: bei 12bit dauert die Datenübertragung zu lange, mit 10Bit je 188ms
  

  myButtons.disableButton(Taste_li_vor_rauf);
  myButtons.disableButton(Taste_li_vor_runter);
  myButtons.disableButton(Taste_re_vor_rauf);
  myButtons.disableButton(Taste_re_vor_runter);
  myButtons.disableButton(Taste_li_hi_rauf);
  myButtons.disableButton(Taste_li_hi_runter);
  myButtons.disableButton(Taste_re_hi_rauf);
  myButtons.disableButton(Taste_re_hi_runter);

  myButtons.disableButton(Taste_fertig);

   

   myGLCD.clrScr();
   myGLCD.fillScr(0, 191,255);
   myButtons.enableButton(Taste_Vent, true);
   myButtons.enableButton(Taste_Stuetzen, true);
  _delay_ms(10);

   soll_EisTemp = EEPROM.read(10);
   sollKtemp= EEPROM.read(11);
   soll_k_luefter= EEPROM.read(12);
   soll_h_luefter= EEPROM.read(16);

  soll_Strom_blockiert= EEPROM.read(13);
  soll_Strom_Endposition= EEPROM.read(14);
  soll_Strom_normal= EEPROM.read(15);
  soll_Solar=EEPROM.read(18);
  Spannung_Kalibrierung=(float)EEPROM.read(17)/10.0-5.0;
  Batterietyp=EEPROM.read(19);
  Endschalter=EEPROM.read(20);
  soll_Timeout_Endpostion=EEPROM.read(21);
  soll_Wasserstand=EEPROM.read(22);

   status_luefter=2;status_luefter_alt=999;// Lüfter auf Automatik
   status_batterie=0;status_batterie_alt=9;// ungleich damit Display beim einschalten was anzeigt



 EisTemp=0;
 KTemp=0;
 Case=Case_Anzeige;
 myButtons.drawButtons();

 //analogWrite(13, dimmer_hell);
}



ISR(TIMER4_COMPA_vect)
{
  static unsigned char tasktimer;
 static unsigned short tasktimersekunde;
  tasktimer++;
  tasktimersekunde++;

 //myGLCD.printNumF(tasktimersekunde, 0, 5, 5);
  
  
  if (tasktimer == TASK100ms) 
    {
    taskflag = task100msflag; 
   }
 
  
  if (tasktimer >= TASKdauer_ms) 
    {
    tasktimer = 0;
   
    }
  if (tasktimer == taskStrom) 
    {
    taskflag = taskStromflag;
    }
  if (tasktimer == taskDisplay) 
    {
    taskflag = taskDisplayflag;
    }

   if (tasktimersekunde>=1000) 
    {
    taskflagS = task1sflag;
    tasktimersekunde=0;
    timeout++;
    }
   if (tasktimersekunde==50) {taskflagS = taskSensorenflag;}



}


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void display_stuetzen()
{
  long temp;
  // Anzeige vom Ampere je Motor, einfï¿½rben je nach Status
  // gelb: anfahren
  // grï¿½n: normal
  // dunkelgrï¿½n: Bodenkontakt
  // rot: Fehler
myGLCD.setFont(DotMatrix_M);
  
  switch (status_m_l_v)
  {
    case Status_warten: myGLCD.setColor(VGA_OLIVE); break;
    case Status_start: myGLCD.setColor(VGA_YELLOW); break;
    case Status_normal: myGLCD.setColor(VGA_GREEN); break;
    case Status_Endposition: myGLCD.setColor(VGA_LIME); break;
    case Status_Fehler: myGLCD.setColor(VGA_RED); break;

  }
  temp = Strom_Motor_li_vo;
  myGLCD.printNumI(temp, 50, 50);
  myGLCD.drawRect(5, 10, 85, 115);
  myGLCD.drawRect(6, 11, 84, 114);
  myGLCD.drawRect(7, 12, 83, 113);

  switch (status_m_r_v)
  {
    case Status_warten: myGLCD.setColor(VGA_OLIVE); break;
    case Status_start: myGLCD.setColor(VGA_YELLOW); break;
    case Status_normal: myGLCD.setColor(VGA_GREEN); break;
    case Status_Endposition: myGLCD.setColor(VGA_LIME); break;
    case Status_Fehler: myGLCD.setColor(VGA_RED); break;

  }
  temp = Strom_Motor_re_vo;
  myGLCD.printNumI(temp, 210, 50);
  myGLCD.drawRect(165, 10, 245, 115);
  myGLCD.drawRect(166, 11, 244, 114);
  myGLCD.drawRect(167, 12, 243, 113);
  
  switch (status_m_l_h)
  {
    case Status_warten: myGLCD.setColor(VGA_OLIVE); break;
    case Status_start: myGLCD.setColor(VGA_YELLOW); break;
    case Status_normal: myGLCD.setColor(VGA_GREEN); break;
    case Status_Endposition: myGLCD.setColor(VGA_LIME); break;
    case Status_Fehler: myGLCD.setColor(VGA_RED); break;

  }
  temp = Strom_Motor_li_hi;
  myGLCD.printNumI(temp, 50, 170);
  myGLCD.drawRect(5, 130, 85, 235);
  myGLCD.drawRect(6, 131, 84, 234);
  myGLCD.drawRect(7, 132, 83, 233);

  switch (status_m_r_h)
  {
    case Status_warten: myGLCD.setColor(VGA_OLIVE); break;
    case Status_start: myGLCD.setColor(VGA_YELLOW); break;
    case Status_normal: myGLCD.setColor(VGA_GREEN); break;
    case Status_Endposition: myGLCD.setColor(VGA_LIME); break;
    case Status_Fehler: myGLCD.setColor(VGA_RED); break;

  }
  temp = Strom_Motor_re_hi;
  myGLCD.printNumI(temp, 210, 170);
  myGLCD.drawRect(165, 130, 245, 235);
  myGLCD.drawRect(166, 131, 244, 234);
  myGLCD.drawRect(167, 132, 243, 233);

myGLCD.setColor(VGA_WHITE);
myGLCD.setFont(Sinclair_S);
}


void Buttons_Stuetzen()
{
  myButtons.disableButton(Taste_li_vor_rauf, true);
  myButtons.disableButton(Taste_li_vor_runter, true);
  myButtons.disableButton(Taste_re_vor_rauf, true);
  myButtons.disableButton(Taste_re_vor_runter, true);
  myButtons.disableButton(Taste_li_hi_rauf, true);
  myButtons.disableButton(Taste_li_hi_runter, true);
  myButtons.disableButton(Taste_re_hi_rauf, true);
  myButtons.disableButton(Taste_re_hi_runter, true);
  myButtons.disableButton(Taste_Stuetzen, true);
  myButtons.disableButton(Taste_Vent, true);
  myButtons.disableButton(Taste_stopp, true);
  myButtons.disableButton(Taste_fertig, true);
  
  myGLCD.clrScr();

  myButtons.enableButton(Taste_Manuell, true);

  myButtons.enableButton(Taste_Auto_rauf, true);
  myButtons.enableButton(Taste_Auto_runter, true);
  myButtons.enableButton(Taste_Anzeige, true);
 

}
void Stuetzen()
{
  dimmer=dimmer_hell; 
  analogWrite(13, dimmer); // Display dimmen
  
  myGLCD.setBackColor(0, 0,0 );
  Buttons_Stuetzen();
  display_stuetzen();
  
  char abbruch = 0;
  char Taste_gedrueckt;

  timeout=0;

  while (abbruch == 0)
  {

  status_m_l_v = Status_warten;
  status_m_r_v = Status_warten;
  status_m_l_h = Status_warten;
  status_m_r_h = Status_warten;
    
    Taste_gedrueckt = myButtons.checkButtons();

    if (Taste_gedrueckt == Taste_Auto_rauf)  {Stuetzen_rauf_automatik();Buttons_Stuetzen();display_stuetzen();}
    if (Taste_gedrueckt == Taste_Auto_runter)  {Stuetzen_runter_automatik();Buttons_Stuetzen();display_stuetzen();}
    if (Taste_gedrueckt == Taste_fertig)  abbruch = 1;
    if (Taste_gedrueckt == Taste_stopp)  abbruch = 1;
    if (Taste_gedrueckt == Taste_Anzeige)  abbruch = 1;
    if (Taste_gedrueckt == Taste_Manuell)  {Manuell();Buttons_Stuetzen();display_stuetzen();}

    if (Taster_Freigabe && Taster_rauf ) {Stuetzen_rauf_automatik();abbruch = 1;}
    if (Taster_Freigabe && Taster_runter) {Stuetzen_runter_automatik();abbruch = 1;}
  
  
    if (timeout>60) abbruch = 1;
  }

  Motor_li_vo_stopp;
  Motor_re_vo_stopp;
  Motor_li_hi_stopp;
  Motor_re_hi_stopp;

  Case=Case_Anzeige;
}


void Strom_kalibrieren()
{
  analogRead(ADC_Motor_li_vo);_delay_us(50);
  Strom_kalib_Motor_li_vo = (analogRead(ADC_Motor_li_vo))*50/1024; //reale Spannung am ADC in V*10
  analogRead(ADC_Motor_re_vo);_delay_us(50);
  Strom_kalib_Motor_re_vo = (analogRead(ADC_Motor_re_vo))*50/1024;
  analogRead(ADC_Motor_li_hi);_delay_us(50);
  Strom_kalib_Motor_li_hi = (analogRead(ADC_Motor_li_hi))*50/1024;
  analogRead(ADC_Motor_re_hi);_delay_us(50);
  Strom_kalib_Motor_re_hi = (analogRead(ADC_Motor_re_hi))*50/1024;

}                                    

void Strom_Motoren()
{
  analogRead(ADC_Motor_li_vo);_delay_us(50);
  Strom_Motor_li_vo = abs(((analogRead(ADC_Motor_li_vo)*50/1024 - Strom_kalib_Motor_li_vo)));  /// 0.1
  analogRead(ADC_Motor_re_vo);_delay_us(50);
  Strom_Motor_re_vo = abs(((analogRead(ADC_Motor_re_vo)*50/1024 - Strom_kalib_Motor_re_vo)));/// 0.1
  analogRead(ADC_Motor_li_hi);_delay_us(50);
  Strom_Motor_li_hi = abs(((analogRead(ADC_Motor_li_hi)*50/1024 - Strom_kalib_Motor_li_hi)));/// 0.1
  analogRead(ADC_Motor_re_hi);_delay_us(50);
  Strom_Motor_re_hi = abs(((analogRead(ADC_Motor_re_hi)*50/1024 - Strom_kalib_Motor_re_hi)));/// 0.1

  if( Strom_Motor_li_vo <0) Strom_Motor_li_vo=0;  if( Strom_Motor_li_vo >9) Strom_Motor_li_vo=9;  
  if( Strom_Motor_re_vo <0) Strom_Motor_re_vo=0;  if( Strom_Motor_re_vo >9) Strom_Motor_re_vo=9; 
  if( Strom_Motor_li_hi <0) Strom_Motor_li_hi=0;  if( Strom_Motor_li_hi >9) Strom_Motor_li_hi=9; 
  if( Strom_Motor_re_hi <0) Strom_Motor_re_hi=0;  if( Strom_Motor_re_hi >9) Strom_Motor_re_hi=9; 

}
//--------------------------------------------------------------------------------------------------
void Stuetzen_runter_automatik()
{

//  unsigned short timer_m_l_v, timer_m_r_v, timer_m_l_h, timer_m_r_h;
  unsigned short timeout_m_l_v, timeout_m_r_v, timeout_m_l_h, timeout_m_r_h;
  unsigned short counter_m_l_v, counter_m_r_v, counter_m_l_h, counter_m_r_h;

  char abbruch = 0;
  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;

  Strom_kalibrieren();
  
  myButtons.disableButton(Taste_Auto_rauf, true);
  myButtons.disableButton(Taste_Auto_runter, true);
  myButtons.disableButton(Taste_Manuell, true);
  myButtons.disableButton(Taste_Anzeige, true);
  myButtons.enableButton(Taste_stopp, true);
 

  status_m_l_v = Status_warten;
  status_m_r_v = Status_warten;
  status_m_l_h = Status_warten;
  status_m_r_h = Status_warten;
  timeout_m_l_v=0;
  timeout_m_r_v=0;
  timeout_m_l_h=0;
  timeout_m_r_h=0;


  Motor_li_hi_runter; // mit diesem Motor starten
  status_m_l_h = Status_start;

  //while (((status_m_l_h < Status_Endposition) && (status_m_r_h < Status_Endposition)) || (abbruch ==0)) // bis hintere Stï¿½tzen unten sind oder Error
  while (abbruch ==0)
   {
   if (taskflag == taskStromflag)
          { taskflag = taskflagclear;
            Strom_Motoren();
      
            // Motor links hinten
            if (status_m_l_h>=Status_start && status_m_l_h<Status_Endposition )
              {
              timeout_m_l_h++;
              
              if (timeout_m_l_h>600) // 1 Minute, wenn dann nicht Bodenkontakt hat es was
                {
                Motor_li_hi_stopp;  
                status_m_l_h = Status_Fehler;       
                }         
      
             }
            
            if ((Strom_Motor_li_hi > soll_Strom_blockiert) && (status_m_l_h == Status_start)) 
              {
              if (timeout_m_l_h > 50)
                {
                  Motor_li_hi_stopp;  // Blockiert schon beim anfahren
                  status_m_l_h = Status_Fehler;
                }
              }

             if ((Strom_Motor_li_hi <= soll_Strom_blockiert) && (Strom_Motor_li_hi >= soll_Strom_normal)&&(status_m_l_h == Status_start)) 
              {
              if (timeout_m_l_h > 100)
                {
                  Motor_li_hi_stopp;  // Nicht erkannter Zustand nach 10s
                  status_m_l_h = Status_Fehler;
                }
              }

             if ((status_m_l_h == Status_Fehler)&&(status_m_r_h < Status_start))
                  {
                  status_m_r_h = Status_start; // nï¿½chsten Motor freigeben
                  Motor_re_hi_runter;
                  }
              
            if ((Strom_Motor_li_hi < soll_Strom_normal)&&(timeout_m_l_h > 10)) // nach 1s
             {
              if (status_m_l_h  == Status_start) // nur einmal Status umschalten
                {
                status_m_l_h = Status_normal; // freies runterfahren
                status_m_r_h = Status_start; // nï¿½chsten Motor freigeben
                Motor_re_hi_runter;
                }
              }
            if ((Strom_Motor_li_hi > soll_Strom_Endposition) && (status_m_l_h == Status_normal))
             {
              counter_m_l_h++;
              if (counter_m_l_h > soll_Timeout_Endpostion)
              {
                Motor_li_hi_stopp;  // Bodenkontakt
                status_m_l_h = Status_Endposition;
              }
             }
            else counter_m_l_h = 0;
      
      	  



        // Motor rechts hinten
      	  if (status_m_r_h>=Status_start && status_m_r_h<Status_Endposition )
            {
            timeout_m_r_h++;
            if (timeout_m_r_h>600) // 1 Minute, wenn dann nicht Bodenkontakt hat es was
              {
              Motor_re_hi_stopp;  // Blockiert schon beim anfahren
              status_m_r_h = Status_Fehler;
              }
            }
      
            
          if ((Strom_Motor_re_hi > soll_Strom_blockiert) && (status_m_r_h == Status_start)) 
            {
              if (timeout_m_r_h > 50)
              {
                Motor_re_hi_stopp;  // Blockiert schon beim anfahren
                status_m_r_h = Status_Fehler;
              }
            }
          if ((Strom_Motor_re_hi <= soll_Strom_blockiert) && (Strom_Motor_re_hi >= soll_Strom_normal)&&(status_m_r_h == Status_start)) 
              {
              if (timeout_m_r_h > 100)
                {
                  Motor_re_hi_stopp;  // Nicht erkannter Zustand nach 10s
                  status_m_r_h = Status_Fehler;
                }
              }

          if ((Strom_Motor_re_hi < soll_Strom_normal)&&(timeout_m_r_h > 10))
            {
              if (status_m_r_h  == Status_start) // nur einmal Status umschalten
                {
                 status_m_r_h = Status_normal; // freies runterfahren
                }
            }
          if ((Strom_Motor_re_hi > soll_Strom_Endposition) && (status_m_r_h == Status_normal))
            {
              counter_m_r_h++;
              if (counter_m_r_h > soll_Timeout_Endpostion)
              {
                Motor_re_hi_stopp;
                status_m_r_h = Status_Endposition;
              }
            }// Bodenkontakt
          else counter_m_r_h = 0;
 

      display_stuetzen(); 
     }// ende taskStrom


    Taste_gedrueckt = myButtons.checkButtons();

    if (Taste_gedrueckt == Taste_fertig)  abbruch = 9;
    if (Taste_gedrueckt == Taste_stopp)  abbruch = 9;
    if ((status_m_l_h >= Status_Endposition) && (status_m_r_h >= Status_Endposition))  abbruch = 1;
    if (Taster_Freigabe && Taster_rauf ) abbruch = 9;
    
/*
   if (taskflag == taskDisplayflag)
    { taskflag = taskflagclear;
      display_stuetzen();
    }
 */ 

  }// ende while

  if (abbruch<9) abbruch=0;
  Motor_li_vo_runter; status_m_l_v = Status_start;

  while ((abbruch == 0)) // bis vordere Stï¿½tzen unten sind oder Error
  {
  if (taskflag == taskStromflag)
    { taskflag = taskflagclear;
      Strom_Motoren();

      // Motor links vorne
      if (status_m_l_v>=Status_start && status_m_l_v<Status_Endposition )
        {
        timeout_m_l_v++;
        if (timeout_m_l_v>600) // 1 Minute, wenn dann nicht Bodenkontakt hat es was
          {
          Motor_li_vo_stopp;  
          status_m_l_v = Status_Fehler;
          }
        }
      
      if ((Strom_Motor_li_vo > soll_Strom_blockiert) && (status_m_l_v == Status_start))
       {
        if (timeout_m_l_v > 50)
        {
          Motor_li_vo_stopp;  // Blockiert schon beim anfahren
          status_m_l_v = Status_Fehler;
        }
       }

      if ((Strom_Motor_li_vo <= soll_Strom_blockiert) && (Strom_Motor_li_vo >= soll_Strom_normal)&&(status_m_l_v == Status_start)) 
              {
              if (timeout_m_l_v > 100)
                {
                  Motor_li_vo_stopp;  // Nicht erkannter Zustand nach 10s
                  status_m_l_v = Status_Fehler;
                }
              }

      if ((status_m_l_v == Status_Fehler)&&(status_m_r_v < Status_start))
            {
            status_m_r_v = Status_start; // nï¿½chsten Motor freigeben
            Motor_re_vo_runter;
            }
     
      if ((Strom_Motor_li_vo < soll_Strom_normal)&&(timeout_m_l_v > 10))
        {
          if (status_m_l_v  == Status_start) // nur einmal Status umschalten
          {
          status_m_l_v = Status_normal; // freies runterfahren
          status_m_r_v = Status_start; // nï¿½chsten Motor freigeben
          Motor_re_vo_runter;
          }
       }
      if ((Strom_Motor_li_vo > soll_Strom_Endposition) && (status_m_l_v == Status_normal))
      {
        counter_m_l_v++;
        if (counter_m_l_v > soll_Timeout_Endpostion)
        {
          Motor_li_vo_stopp;  // Bodenkontakt
          status_m_l_v = Status_Endposition;
        }
      }
      else counter_m_l_v = 0;
	  
	  
  	


      // Motor rechts vorne
      if (status_m_r_v>=Status_start && status_m_r_v<Status_Endposition )
        {
        timeout_m_r_v++;
        if (timeout_m_r_v>600) // 1 Minute, wenn dann nicht Bodenkontakt hat es was
          {
          Motor_re_vo_stopp;  // Blockiert schon beim anfahren
          status_m_r_v = Status_Fehler;
          }
        }
      if ((Strom_Motor_re_vo > soll_Strom_blockiert) && (status_m_r_v == Status_start)) 
        {
        if (timeout_m_r_v > 50)
         {
          Motor_re_vo_stopp;  // Blockiert schon beim anfahren
          status_m_r_v = Status_Fehler;
         }
        }
      if ((Strom_Motor_re_vo <= soll_Strom_blockiert) && (Strom_Motor_re_vo >= soll_Strom_normal)&&(status_m_r_v == Status_start)) 
              {
              if (timeout_m_r_v > 100)
                {
                  Motor_re_vo_stopp;  // Nicht erkannter Zustand nach 10s
                  status_m_r_v = Status_Fehler;
                }
              }
      if ((Strom_Motor_re_vo < soll_Strom_normal)&&(timeout_m_r_v > 10))
        {
           if (status_m_r_v  == Status_start) // nur einmal Status umschalten
            {
            status_m_r_v = Status_normal; // freies runterfahren
            }
        }
        
      if ((Strom_Motor_re_vo > soll_Strom_Endposition) && (status_m_r_v == Status_normal))
      {
        counter_m_r_v++;
        if (counter_m_r_v > soll_Timeout_Endpostion)
         {
          Motor_re_vo_stopp;
          status_m_r_v = Status_Endposition;
         }
      }// Bodenkontakt
      else counter_m_r_v = 0;
	
	
    
    display_stuetzen();
    } // ende taskStrom


    Taste_gedrueckt = myButtons.checkButtons();

    if (Taste_gedrueckt == Taste_fertig)  abbruch = 9;
    if (Taste_gedrueckt == Taste_stopp)  abbruch = 9;
    if ((status_m_l_v >= Status_Endposition) && (status_m_r_v >= Status_Endposition)) abbruch = 1;

    if (Taster_Freigabe && Taster_rauf ) abbruch = 9;

/*
    if (taskflag == taskDisplayflag)
    { taskflag = taskflagclear;
      display_stuetzen();

    }
*/





  } // ende while
Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;
while (Taster_rauf); // warten bis Taster losgelassen
}
//--------------------------------------------------------------------------------------------------
void Stuetzen_rauf_automatik()
{

 // unsigned short timer_m_l_v, timer_m_r_v, timer_m_l_h, timer_m_r_h;
  unsigned short timeout_m_l_v, timeout_m_r_v, timeout_m_l_h, timeout_m_r_h;
  unsigned short counter_m_l_v, counter_m_r_v, counter_m_l_h, counter_m_r_h;


  char abbruch = 0;
  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;

  Strom_kalibrieren();

  myButtons.disableButton(Taste_Manuell, true);
  myButtons.disableButton(Taste_Anzeige, true);
  myButtons.enableButton(Taste_stopp, true);

  status_m_l_v = Status_warten;
  status_m_r_v = Status_warten;
  status_m_l_h = Status_warten;
  status_m_r_h = Status_warten;
  timeout_m_l_v=0;
  timeout_m_r_v=0;
  timeout_m_l_h=0;
  timeout_m_r_h=0;


  Motor_li_vo_rauf; // mit diesem Motor starten
  status_m_l_v = Status_start;
  while ((abbruch == 0)) // bis vordere Stï¿½tzen unten sind oder Error
  {
   if (taskflag == taskStromflag)
    { taskflag = taskflagclear;
      Strom_Motoren();

      // Motor links vorne
      if (status_m_l_v>=Status_start && status_m_l_v<Status_Endposition )
        {
        timeout_m_l_v++;
        if (timeout_m_l_v>600) //  1 Minute, wenn keine Statusänderung hat es was
          {
          Motor_li_vo_stopp;  
          status_m_l_v = Status_Fehler;
          }
        }
      
      if ((Strom_Motor_li_vo > soll_Strom_blockiert) && (status_m_l_v == Status_start)) 
        {
        if (timeout_m_l_v > 50)
          {
            Motor_li_vo_stopp;  // Blockiert schon beim anfahren
            status_m_l_v = Status_Fehler;
          }
        }
      if ((Strom_Motor_li_vo <= soll_Strom_blockiert) && (Strom_Motor_li_vo >= soll_Strom_normal)&&(status_m_l_v == Status_start)) 
              {
              if (timeout_m_l_v > 100)
                {
                  Motor_li_vo_stopp;  // Nicht erkannter Zustand nach 10s
                  status_m_l_v = Status_Fehler;
                }
              }
              
      if ((status_m_l_v == Status_Fehler)&&(status_m_r_v < Status_start))
          {
          status_m_r_v = Status_start; // nï¿½chsten Motor freigeben
          Motor_re_vo_rauf;
          }


      if ((Strom_Motor_li_vo < soll_Strom_normal)&&(timeout_m_l_v > 10))
        {
          if (status_m_l_v == Status_start) // nur einmal Status umschalten
            {
            status_m_l_v = Status_normal; // freies runterfahren
            status_m_r_v = Status_start; // nï¿½chsten Motor freigeben
            Motor_re_vo_rauf;
            }
        }
      if ((Strom_Motor_li_vo > soll_Strom_Endposition) && (status_m_l_v == Status_normal))
        {
          counter_m_l_v++;
          if (counter_m_l_v > soll_Timeout_Endpostion)
          {
           Motor_li_vo_stopp;  
           if (Endschalter==Endschalter_vorhanden) status_m_l_v = Status_Fehler;
           else status_m_l_v = Status_Endposition;
          
          }
        }
      else counter_m_l_v = 0;
	  
	  
	  
	  
	  

      // Motor rechts vorne
      if (status_m_r_v>=Status_start && status_m_r_v<Status_Endposition )
        {
        timeout_m_r_v++;
        if (timeout_m_r_v>600) //  1 Minute, wenn keine Statusänderung hat es was
          {
          Motor_re_vo_stopp;  
          status_m_r_v = Status_Fehler;
          }
        }
      if ((Strom_Motor_re_vo > soll_Strom_blockiert) && (status_m_r_v == Status_start))
        {
        if (timeout_m_r_v > 50)
          {
            Motor_re_vo_stopp;  // Blockiert schon beim anfahren
            status_m_r_v = Status_Fehler;
          }
        }

      if ((Strom_Motor_re_vo <= soll_Strom_blockiert) && (Strom_Motor_re_vo >= soll_Strom_normal)&&(status_m_r_v == Status_start)) 
              {
              if (timeout_m_r_v > 100)
                {
                  Motor_re_vo_stopp;  // Nicht erkannter Zustand nach 10s
                  status_m_r_v = Status_Fehler;
                }
              }

      if ((Strom_Motor_re_vo < soll_Strom_normal)&&(timeout_m_r_v > 10))
        {
          if (status_m_r_v == Status_start) // nur einmal Status umschalten
            {
            status_m_r_v = Status_normal; // freies runterfahren
            }
        }
      if ((Strom_Motor_re_vo > soll_Strom_Endposition) && (status_m_r_v == Status_normal))
        {
          counter_m_r_v++;
          if (counter_m_r_v > soll_Timeout_Endpostion)
          {
            Motor_re_vo_stopp;
           if (Endschalter==Endschalter_vorhanden) status_m_r_v = Status_Fehler;
           else status_m_r_v = Status_Endposition;
          }
        }// Bodenkontakt
      else counter_m_r_v = 0;

	 
      display_stuetzen();
    } // ende taskstrom


    if (Endschalter==Endschalter_vorhanden)
    {
      if (Endschalter_li_vo) {
        Motor_li_vo_stopp;
        status_m_l_v = Status_Endposition;
        }
      if (Endschalter_re_vo) {
        Motor_re_vo_stopp;
        status_m_r_v = Status_Endposition;
       }
    }

    Taste_gedrueckt = myButtons.checkButtons();

    if (Taste_gedrueckt == Taste_fertig)  abbruch = 9;
    if (Taste_gedrueckt == Taste_stopp)  abbruch = 9;
    if ((status_m_l_v >= Status_Endposition) && (status_m_r_v >= Status_Endposition)) abbruch = 1;

    if (Taster_Freigabe && Taster_runter ) abbruch = 9;


/*
   if (taskflag == taskDisplayflag)
    { taskflag = taskflagclear;
      display_stuetzen();

    }
*/
 
  } // ende while

  if (abbruch<9) abbruch=0;
  Motor_li_hi_rauf; // mit diesem Motor starten
  status_m_l_h = Status_start;
  while ((abbruch == 0)) // bis hintere Stï¿½tzen unten sind oder Error
  {
   if (taskflag == taskStromflag)
    { taskflag = taskflagclear;
      Strom_Motoren();

      // Motor links hinten
      if (status_m_l_h>=Status_start && status_m_l_h<Status_Endposition )
        {
        timeout_m_l_h++;
        if (timeout_m_l_h>600)  //1 Minute, wenn keine Statusänderung hat es was
          {
          Motor_li_hi_stopp;  
          status_m_l_h = Status_Fehler;
          }
        }
      
      if ((Strom_Motor_li_hi > soll_Strom_blockiert) && (status_m_l_h == Status_start))
        {
        if (timeout_m_l_h > 50)
          {
            Motor_li_hi_stopp;  // Blockiert schon beim anfahren
            status_m_l_h = Status_Fehler;
          }
        }

      if ((Strom_Motor_li_hi <= soll_Strom_blockiert) && (Strom_Motor_li_hi >= soll_Strom_normal)&&(status_m_l_h == Status_start)) 
              {
              if (timeout_m_l_h > 100)
                {
                  Motor_li_hi_stopp;  // Nicht erkannter Zustand nach 10s
                  status_m_l_h = Status_Fehler;
                }
              }
      
      if ((status_m_l_h == Status_Fehler)&&(status_m_r_h < Status_start))
          {
          status_m_r_h = Status_start; // nï¿½chsten Motor freigeben
          Motor_re_hi_rauf;
          }

      if ((Strom_Motor_li_hi < soll_Strom_normal)&&(timeout_m_l_h > 10))  
        {
         if (status_m_l_h == Status_start) // nur einmal Status umschalten
          {
          status_m_l_h = Status_normal; // freies runterfahren
          status_m_r_h = Status_start; // nï¿½chsten Motor freigeben
          Motor_re_hi_rauf;
          }
       }
      
      if ((Strom_Motor_li_hi > soll_Strom_Endposition) && (status_m_l_h == Status_normal))
        {
          counter_m_l_h++;
          if (counter_m_l_h > soll_Timeout_Endpostion)
          {
            Motor_li_hi_stopp;  
           if (Endschalter==Endschalter_vorhanden) status_m_l_h = Status_Fehler;
           else status_m_l_h = Status_Endposition;
          
          }
        }
      else counter_m_l_h = 0;
	
		
      // Motor rechts hinten
    if (status_m_r_h>=Status_start && status_m_r_h<Status_Endposition  )
        {
        timeout_m_r_h++;
        if (timeout_m_r_h>600) // 1 Minute, wenn keine Statusänderung hat es was
          {
          Motor_re_hi_stopp;  
          status_m_r_h = Status_Fehler;
          }
        }
      
      if ((Strom_Motor_re_hi > soll_Strom_blockiert) && (status_m_r_h == Status_start))
        {
        if (timeout_m_r_h > 50)
          {
            Motor_re_hi_stopp;  // Blockiert schon beim anfahren
            status_m_r_h = Status_Fehler;
          }
        }

      if ((Strom_Motor_re_hi <= soll_Strom_blockiert) && (Strom_Motor_re_hi >= soll_Strom_normal)&&(status_m_r_h == Status_start)) 
              {
              if (timeout_m_r_h > 100)
                {
                  Motor_re_hi_stopp;  // Nicht erkannter Zustand nach 10s
                  status_m_r_h = Status_Fehler;
                }
              }
      
      if ((Strom_Motor_re_hi < soll_Strom_normal)&&(timeout_m_r_h > 10))
        {
          if (status_m_r_h == Status_start) // nur einmal Status umschalten
            {
            status_m_r_h = Status_normal; // freies runterfahren
            }
        }
      if ((Strom_Motor_re_hi > soll_Strom_Endposition) && (status_m_r_h == Status_normal))
        {
          counter_m_r_h++;
          if (counter_m_r_h > soll_Timeout_Endpostion)
          {
            Motor_re_hi_stopp;
            if (Endschalter==Endschalter_vorhanden) status_m_r_h = Status_Fehler;
            else status_m_r_h = Status_Endposition;
            
          }
        }
      else counter_m_r_h = 0;

	
     display_stuetzen();
    }// ende taskstrom

    if (Endschalter==Endschalter_vorhanden)
    {
      if (Endschalter_li_hi) {
        Motor_li_hi_stopp;
        status_m_l_h = Status_Endposition;
      }
      if (Endschalter_re_hi) {
        Motor_re_hi_stopp;
        status_m_r_h = Status_Endposition;
      }
    }
    
    Taste_gedrueckt = myButtons.checkButtons();

    if (Taste_gedrueckt == Taste_fertig)  abbruch = 9;
    if (Taste_gedrueckt == Taste_stopp)  abbruch = 9;
    if ((status_m_l_h >= Status_Endposition) && (status_m_r_h >= Status_Endposition)) abbruch = 1;

    if (Taster_Freigabe && Taster_runter ) abbruch = 9;


/*
   if (taskflag == taskDisplayflag)
    { taskflag = taskflagclear;
      display_stuetzen();
    }
*/
   
  } // ende while

    Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;
    while(Taster_runter); // warten bis Taster losgelassen


}// Ende Automatik





//======================================================================================================
//====================================    Einzelbetrieb       ==========================================
//======================================================================================================

void Manuell()
{

  unsigned short counter_m_l_v, counter_m_r_v, counter_m_l_h, counter_m_r_h;
  counter_m_l_v=0;
  counter_m_r_v=0;
  counter_m_l_h=0;
  counter_m_r_h=0;


  char abbruch = 0;

  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;
 
	myButtons.disableButton(Taste_stopp, true);
	myButtons.disableButton(Taste_Stuetzen, true);
	myButtons.disableButton(Taste_Anzeige, true);
	myButtons.disableButton(Taste_Manuell, true);
	myButtons.disableButton(Taste_Auto_rauf, true);
	myButtons.disableButton(Taste_Auto_runter, true);
myGLCD.clrScr();
//  myButtons.enableButton(Taste_stopp, true);
	myButtons.enableButton(Taste_fertig, true);
	myButtons.enableButton(Taste_li_vor_rauf, true);
	myButtons.enableButton(Taste_li_vor_runter, true);
	myButtons.enableButton(Taste_re_vor_rauf, true);
	myButtons.enableButton(Taste_re_vor_runter, true);
	myButtons.enableButton(Taste_li_hi_rauf, true);
	myButtons.enableButton(Taste_li_hi_runter, true);
	myButtons.enableButton(Taste_re_hi_rauf, true);
	myButtons.enableButton(Taste_re_hi_runter, true);


  Strom_kalibrieren();

  status_m_l_v = Status_normal;
  status_m_r_v = Status_normal;
  status_m_l_h = Status_normal;
  status_m_r_h = Status_normal;

  timeout=0;

  while (abbruch == 0) // bis vordere Stï¿½tzen unten sind oder Error
  {
   if (taskflag == taskStromflag)
    { taskflag = taskflagclear;
      Strom_Motoren();

      // Motor links vorne
      if (Strom_Motor_li_vo > soll_Strom_blockiert)
      {
        counter_m_l_v++;
        if (counter_m_l_v > soll_Timeout_Endpostion)// Bodenkontakt
        {counter_m_l_v=soll_Timeout_Endpostion+1;
          Motor_li_vo_stopp;status_m_l_v = Status_Endposition;
        }
      }
      else {counter_m_l_v = 0;status_m_l_v=Status_normal;}

       if (Endschalter==Endschalter_vorhanden)
        {
          if ((Endschalter_li_vo) && (Taste_li_vor_rauf)) {
            Motor_li_vo_stopp;status_m_l_v = Status_Endposition;
          }
          else status_m_l_v=Status_normal;
        }


      // Motor rechts vorne
      if (Strom_Motor_re_vo > soll_Strom_blockiert)
      {
        counter_m_r_v++;
        if (counter_m_r_v > soll_Timeout_Endpostion)// Bodenkontakt
        {counter_m_r_v=soll_Timeout_Endpostion+1;
          Motor_re_vo_stopp; status_m_r_v = Status_Endposition;
        }
      }
      else {counter_m_r_v = 0;status_m_r_v = Status_normal;}

      if (Endschalter==Endschalter_vorhanden)
        {
        if ((Endschalter_re_vo) && (Taste_re_vor_rauf)) 
          {
          Motor_re_vo_stopp;status_m_r_v = Status_Endposition;
          }
        else status_m_r_v=Status_normal;
        }

      // Motor links hinten
      if (Strom_Motor_li_hi > soll_Strom_blockiert)
      {
        counter_m_l_h++;
        if (counter_m_l_h > soll_Timeout_Endpostion)// Bodenkontakt
        { counter_m_l_h=soll_Timeout_Endpostion+1;
          Motor_li_hi_stopp;status_m_l_h = Status_Endposition;
        }
      }
      else {counter_m_l_h = 0;status_m_l_v=Status_normal;}

       if (Endschalter==Endschalter_vorhanden)
        {
        if ((Endschalter_li_hi) && (Taste_li_vor_rauf)) {
           Motor_li_hi_stopp;status_m_l_h = Status_Endposition;
           }
        else status_m_l_h=Status_normal;
        }


      // Motor rechts hinten
      if (Strom_Motor_re_hi > soll_Strom_blockiert)
      {
        counter_m_r_h++;
        if (counter_m_r_h > soll_Timeout_Endpostion)
        {counter_m_r_h=soll_Timeout_Endpostion+1;
          Motor_re_hi_stopp;status_m_r_h = Status_Endposition;
        }
      }
      else {counter_m_r_h = 0;status_m_l_v=Status_normal;}

        if (Endschalter==Endschalter_vorhanden)
        {
          if ((Endschalter_re_hi) && (Taste_re_hi_rauf)) {
            Motor_re_hi_stopp;status_m_r_h = Status_Endposition;
           }
          else status_m_r_h =Status_normal;
        }

     } // task

/*    if (taskflag == taskDisplayflag)
      { taskflag = taskflagclear;
         display_stuetzen();
      
      }
  */  
  display_stuetzen();

    Taste_gedrueckt = myButtons.checkButtons_X();

    if ((Taste_gedrueckt == Taste_li_vor_rauf)&&(status_m_l_v != Status_Endposition))  {Motor_li_vo_rauf;timeout=0;}
    if ((Taste_gedrueckt == Taste_li_vor_runter)&&(status_m_l_v != Status_Endposition))  {Motor_li_vo_runter;timeout=0;}
 
    if ((Taste_gedrueckt == Taste_re_vor_rauf)&&(status_m_r_v != Status_Endposition))  {Motor_re_vo_rauf;timeout=0;}
    if ((Taste_gedrueckt == Taste_re_vor_runter)&&(status_m_r_v != Status_Endposition))  {Motor_re_vo_runter;timeout=0;}

    if ((Taste_gedrueckt == Taste_li_hi_rauf)&&(status_m_l_h != Status_Endposition))  {Motor_li_hi_rauf;timeout=0;}
    if ((Taste_gedrueckt == Taste_li_hi_runter)&&(status_m_l_h != Status_Endposition))  {Motor_li_hi_runter;timeout=0;}

    if ((Taste_gedrueckt == Taste_re_hi_rauf)&&(status_m_r_h != Status_Endposition))  {Motor_re_hi_rauf;timeout=0;}
    if ((Taste_gedrueckt == Taste_re_hi_runter)&&(status_m_r_h != Status_Endposition))  {Motor_re_hi_runter;timeout=0;}

    if (Taste_gedrueckt == Taste_fertig)  abbruch = 1;
    if (Taste_gedrueckt == Taste_stopp) {  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;}


    if (Taste_gedrueckt == -1) // keine Taste
      {  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;}

    if (timeout>60) {abbruch = 1;timeout=0;}
    
  }// ende while



  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;

  myButtons.disableButton(Taste_li_vor_rauf, true);
  myButtons.disableButton(Taste_li_vor_runter, true);
  myButtons.disableButton(Taste_re_vor_rauf, true);
  myButtons.disableButton(Taste_re_vor_runter, true);
  myButtons.disableButton(Taste_li_hi_rauf, true);
  myButtons.disableButton(Taste_li_hi_runter, true);
  myButtons.disableButton(Taste_re_hi_rauf, true);
  myButtons.disableButton(Taste_re_hi_runter, true);

  myButtons.disableButton(Taste_fertig, true);
myGLCD.clrScr();

}

//=============================================================================================================================================================
//======================================================================    Anzeige       =====================================================================
//=============================================================================================================================================================
void Anzeige()
{
  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;
  myButtons.disableButton(Taste_li_vor_rauf, true);
  myButtons.disableButton(Taste_li_vor_runter, true);
  myButtons.disableButton(Taste_re_vor_rauf, true);
  myButtons.disableButton(Taste_re_vor_runter, true);
  myButtons.disableButton(Taste_li_hi_rauf, true);
  myButtons.disableButton(Taste_li_hi_runter, true);
  myButtons.disableButton(Taste_re_hi_rauf, true);
  myButtons.disableButton(Taste_re_hi_runter, true);
  myButtons.disableButton(Taste_Auto_rauf, true);
  myButtons.disableButton(Taste_Auto_runter, true);
  myButtons.disableButton(Taste_fertig, true);
  myButtons.disableButton(Taste_stopp, true);
  myButtons.disableButton(Taste_Anzeige, true);
  myButtons.disableButton(Taste_n_Funktion, true);
  myButtons.disableButton(Taste_Ok, true);
  myGLCD.clrScr(); 
  myGLCD.fillScr(0, 191,255);
  myButtons.enableButton(Taste_Vent, true);
  myButtons.enableButton(Taste_Stuetzen, true);
  myButtons.enableButton(Taste_Einstell, true);

  
  status_luefter_alt=999;// ungleich damit Display beim einschalten was anzeigt
  status_batterie_alt=9;

 // grafiken dauern lange zum anzeigen, wenn möglich nur einmal anzeigen
  myGLCD.setBackColor(0, 191, 255);
  myGLCD.drawTransBitmap(8,7,48,48,battery,0);
  if (soll_Solar==1){myGLCD.drawTransBitmap(200,20,32,32,solar,0);}
  myGLCD.drawTransBitmap(10,90,70,70,refrigerator,0); 
  myGLCD.drawTransBitmap(200,100,40,40,wasser,0);
  dimmer=dimmer_hell; 
  analogWrite(13, dimmer); // Display dimmen
      
while (Case==Case_Anzeige)
{

  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;
   if (myTouch.dataAvailable()) // nur überrpüfen ob Taste gedrückt, dann Display auf hell
   {
    sekunden=0;
    if (dimmer!=dimmer_hell)
      {
      dimmer=dimmer_hell; 
      analogWrite(13, dimmer); // Display dimmen
      }
   } 

 
  Taste_gedrueckt = myButtons.checkButtons();
  if (Taste_gedrueckt == Taste_Stuetzen) {Case=Case_stuetzen;}
  if (Taste_gedrueckt == Taste_Einstell)  {Case=Case_einstell;}
  if (Taste_gedrueckt == Taste_Vent)  {status_luefter++;}

  if (Taster_Freigabe &&(Taster_rauf || Taster_runter)) {Case=Case_stuetzen;}

 // Kühlschranklüfter
  if (status_luefter_alt!=status_luefter)
  {
   status_luefter_alt=status_luefter;
   myGLCD.setFont(arial_bold);
//   myGLCD.setBackColor(0, 191, 255);
   switch (status_luefter)
      {
      case 0: 
      myGLCD.setColor(VGA_GRAY);myGLCD.print(" Aus ", 73, 190); Ventilator_aus;
      break;
      case 1:
      myGLCD.setColor(VGA_GREEN);myGLCD.print(" Ein ", 73, 190); Ventilator_ein;
      break;
      case 2: 
      myGLCD.setColor(VGA_LIME);myGLCD.print("Auto", 80, 190);
      break;
      case 3:
      status_luefter=0;
      break;
      }
    
   }


// Abfrage Sensoren ---------------------------------------------------------

 if (taskflagS == taskSensorenflag)
    { taskflagS = taskflagclear;

     Strom_Solar = (analogRead(ADC_Solar_Strom));_delay_ms(1);
     // Sensor 20A
     //Strom_Solar = (analogRead(ADC_Solar_Strom)*50.0)/1024.0-25.0; // Sensor 20A
     // Sensor 5A
     Strom_Solar = abs((analogRead(ADC_Solar_Strom)-512.0)*5000.0); // 2.5V =512 abziehen, *5000mV
     Strom_Solar =Strom_Solar/185.0/1024.0;   // durch 185mV/A, durch 1024 ADC max
     

     Spannung_Batterie= (analogRead(ADC_Batterie_Spannung)); // Dummy auslesen
     Spannung_Batterie= (analogRead(ADC_Batterie_Spannung));_delay_ms(1); // Dummy auslesen
     Spannung_Batterie= (analogRead(ADC_Batterie_Spannung)*285.0)/(10240.0)+ Spannung_Kalibrierung; //spannungsteiler 47k/10k

    sensors.requestTemperatures();  // Temperaturen abfragen
    if (dallas_sensor_counter==0) EisTemp = sensors.getTempCByIndex(0);
    if (dallas_sensor_counter==1) KTemp = sensors.getTempCByIndex(1);
    if (dallas_sensor_counter==2) LTemp = sensors.getTempCByIndex(2);
    dallas_sensor_counter++;if (dallas_sensor_counter>=3)dallas_sensor_counter=0;


   
    }

 if (taskflagS == task1sflag)
   { 
    taskflagS = taskflagclear;
    sekunden++;
    sekunde_wasser++;if (sekunde_wasser>Intervall_Wassermessung)sekunde_wasser=0;
    
    if (sekunden>120)dimmer=dimmer_abgedunkelt;
    else dimmer=dimmer_hell; 
    if (sekunden>240) {sekunden=3600;dimmer=dimmer_dunkel;}
    analogWrite(13, dimmer); // Display dimmen
    
    myGLCD.setColor(255, 255, 255);
    myGLCD.setBackColor(0, 191, 255);
    myGLCD.setFont(arial_bold);

//************************* Batteriespannung ****************//
  
  
//      if (Spannung_Batterie >19.9) Spannung_Batterie=19.9;
      
     
        if (Batterietyp==Batterie_Blei)
          {
          if (Spannung_Batterie > 12.95) {status_batterie=4; }
          if (Spannung_Batterie > 15.0) {status_batterie=5; }
          if (Spannung_Batterie < 12.74) {status_batterie=3;}
          if (Spannung_Batterie < 12.54) {status_batterie=2;}
          if (Spannung_Batterie < 12.24) {status_batterie=1;}
          if (Spannung_Batterie < 12.0) {status_batterie=0;}
          }
      if (Batterietyp==Batterie_LiFePo4)
          {
          if (Spannung_Batterie >= 13.2) {status_batterie=3;}
          if (Spannung_Batterie > 13.4) {status_batterie=4; }
          if (Spannung_Batterie > 14.6) {status_batterie=5; }
          
          if (Spannung_Batterie < 13.2) {status_batterie=2;}
          if (Spannung_Batterie < 12.8) {status_batterie=1;}
          if (Spannung_Batterie < 12.5) {status_batterie=0;}
          }
        
     if (status_batterie_alt!=status_batterie)
        {
        status_batterie_alt=status_batterie;
        myGLCD.drawTransBitmap(8,7,48,48,battery,0);
        switch (status_batterie)
          {
          case 0: 
          myGLCD.setColor(VGA_RED); 
          myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-5); 
          break;
          case 1:
           myGLCD.setColor(VGA_YELLOW);
          myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-12); 
          break;
          case 2: 
          myGLCD.setColor(VGA_GREEN);
          myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-19);
          break;
          case 3:
          myGLCD.setColor(VGA_GREEN);
          myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-26);
          break;
          case 4: 
          myGLCD.setColor(VGA_LIME);
          myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-31); 
          break;
          case 5: 
          myGLCD.setColor(VGA_RED);
          myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-31); 
          break;
          }
         }
    
    
    
        // für richtige Farbe der Spannungsanzeige
         switch (status_batterie)
          {
          case 0:     
           myGLCD.setColor(VGA_RED); 
         // myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-5);   
          break;
          case 1:     
          myGLCD.setColor(VGA_YELLOW);
         // myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-10);      
          break;
          case 2: 
          myGLCD.setColor(VGA_GREEN);
        //  myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-15);
          break;
          case 3:
          myGLCD.setColor(VGA_GREEN);
        //  myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-25);
          break;
          case 4: 
          myGLCD.setColor(VGA_LIME);
        //  myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-35); 
          break;
          case 5: 
          myGLCD.setColor(VGA_RED);
        //  myGLCD.fillRoundRect(8+14,7+42,8+14+18,7+42-35); 
          break;
          }
    
        dtostrf( Spannung_Batterie, 5, 1, buffer );  
    
        myGLCD.print(buffer, 65, 25);
        myGLCD.print("V", 150, 25);


/********************************************************/
// Solar                                            
// Anzeige Strom                          
///                                                     
/********************************************************/

     // myGLCD.drawBitmap(200,20,32,32,solar);
    //  myGLCD.drawTransBitmap(200,20,32,32,solar,0);
      if (soll_Solar==1)
        {
        myGLCD.setFont(arial_bold);
        if (Strom_Solar>0.5) myGLCD.setColor(VGA_LIME);
        else myGLCD.setColor(VGA_WHITE);
       // if (Strom_Solar<(-0.5)) myGLCD.setColor(VGA_RED); 
        dtostrf( Strom_Solar, 4, 1, buffer );   
        myGLCD.print(buffer, 230, 25);
        myGLCD.print("A", 297, 25);  
        }
       //else  {myGLCD.setColor(VGA_WHITE);myGLCD.print("--", 230, 25); }

/********************************************************/
// Kühlschrank                                                 
// Lueftersteuerung
/********************************************************/
        if (status_luefter_aktuell>=100) status_luefter_aktuell=100; // Ruecksetzen, ausgenommen bei LTemp
        else status_luefter_aktuell=0; 

        if (char(LTemp)>(soll_k_luefter+soll_h_luefter/2)) status_luefter_aktuell=status_luefter_aktuell+100;
        if (char(LTemp)<(soll_k_luefter-soll_h_luefter/2)) status_luefter_aktuell=0;


        myGLCD.setFont(arial_bold);
        if (EisTemp>soll_EisTemp) 
        {myGLCD.setColor(255, 0, 0);//status_luefter_aktuell=status_luefter_aktuell+1;
        }
        else myGLCD.setColor(255, 255, 255);
        
        dtostrf( EisTemp, 5, 1, buffer );  
        myGLCD.print(buffer, 65, 95);
        myGLCD.print("C", 150, 95);
    
    
        if (KTemp>sollKtemp) 
        {myGLCD.setColor(255, 0, 0);//status_luefter_aktuell=status_luefter_aktuell+1;
        }
        else myGLCD.setColor(255, 255, 255);
     
        dtostrf( KTemp, 5, 1, buffer );  
        myGLCD.print(buffer, 65, 135);
        myGLCD.print("C", 150, 135);


       

    
        if ((status_luefter==2)&&(status_luefter_aktuell>=1)) 
          {
          Ventilator_ein;   
          myGLCD.setFont(SmallFont);myGLCD.setColor(VGA_GREEN);
          myGLCD.print("Ein", 100, 210);     
          }
        if ((status_luefter==2)&&(status_luefter_aktuell==0)) 
          {
          Ventilator_aus;   
          myGLCD.setFont(SmallFont);myGLCD.setColor(VGA_GRAY);
          myGLCD.print("Aus", 100, 210);     
          }
         if (status_luefter<2) myGLCD.print("   ", 100, 210);    

       myGLCD.setFont(SmallFont);myGLCD.setColor(VGA_WHITE);
       dtostrf( LTemp, 5, 1, buffer );  
        myGLCD.print(buffer, 85, 225);
        myGLCD.print("C", 125, 225);
    
    /********************************************************/
    //                                                    
    // Anzeige  Wasserstands                            
    // nur vor der Messung den Strom (pullup) einschalten
    // Messung ADC (mit Pullup) gegen Masse                                                    
    /********************************************************/
      
    
   //myGLCD.drawBitmap(200,100,40,40,wasser);
//   myGLCD.drawTransBitmap(200,100,40,40,wasser,0);


  if(sekunde_wasser==1) // pullup einschalten  
    {pinMode(A8,INPUT_PULLUP);pinMode(A9,INPUT_PULLUP);pinMode(A10,INPUT_PULLUP);pinMode(A11,INPUT_PULLUP);}
  if(sekunde_wasser==2)
    {  
      myGLCD.setFont(SmallFont);myGLCD.setColor(VGA_WHITE);
       temp_wasser0=analogRead(A11);
       temp_wasser1=analogRead(A10);
       temp_wasser2=analogRead(A9);
       temp_wasser3=analogRead(A8);
       /*
       myGLCD.print("    ",  150, 180);myGLCD.printNumI(temp_wasser0,150,180);
       myGLCD.print("    ",  150, 195);myGLCD.printNumI(temp_wasser1,150,195);
       myGLCD.print("    ",  150, 209);myGLCD.printNumI(temp_wasser2,150,209);
       myGLCD.print("    ",  150, 222);myGLCD.printNumI(temp_wasser3,150,222);
      */
      if (temp_wasser0>(soll_Wasserstand*10))wasserstand=0;
      if (temp_wasser0<=(soll_Wasserstand*10))wasserstand=1;
      if (temp_wasser1<=(soll_Wasserstand*10))wasserstand=2;
      if (temp_wasser2<=(soll_Wasserstand*10))wasserstand=3;
      if (temp_wasser3<=(soll_Wasserstand*10))wasserstand=4;
    
      if ((temp_wasser0>(soll_Wasserstand*10))&&(temp_wasser1<(soll_Wasserstand*10))) {myGLCD.setColor(VGA_RED);myGLCD.print("Fehler",  245, 130);}
      else myGLCD.print("            ",  245, 130);
      
      myGLCD.setFont(arial_bold);
      switch (wasserstand)
          {
          case 0: 
          myGLCD.setColor(VGA_RED);myGLCD.print("LEER", 245, 110);
          break;
          case 1:
          myGLCD.setColor(VGA_YELLOW);myGLCD.print("1/4 ", 245, 110);
          break;
          case 2: 
          myGLCD.setColor(VGA_WHITE);myGLCD.print("1/2 ",  245, 110);
          break;
          case 3:
          myGLCD.setColor(VGA_LIME);myGLCD.print("3/4 ",  245, 110);
          break;
          case 4:
          myGLCD.setColor(VGA_LIME);myGLCD.print("Voll",  245, 110);
          break;
          }
     
      // pullup auschalten  
      pinMode(A8,INPUT);pinMode(A9,INPUT);pinMode(A10,INPUT);pinMode(A11,INPUT);

      } // ende wasser
   } // ende task display

}// ende while

} // ende Anzeige

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void Einstellungen()
{
char abbruch=0,abbruch_ok=0;
char x=0;
char buffer[10];
char soll_EisTemp_alt, sollKtemp_alt, soll_k_luefter_alt,soll_h_luefter_alt;
char soll_Strom_blockiert_alt, soll_Strom_Endposition_alt, soll_Strom_normal_alt,soll_Timeout_Endpostion_alt,soll_Wasserstand_alt;
  
  myButtons.disableButton(Taste_li_vor_rauf, true);
  myButtons.disableButton(Taste_li_vor_runter, true);
  myButtons.disableButton(Taste_re_vor_rauf, true);
  myButtons.disableButton(Taste_re_vor_runter, true);
  myButtons.disableButton(Taste_li_hi_rauf, true);
  myButtons.disableButton(Taste_li_hi_runter, true);
  myButtons.disableButton(Taste_re_hi_rauf, true);
  myButtons.disableButton(Taste_re_hi_runter, true);
  
  myButtons.disableButton(Taste_stopp, true);
  myButtons.disableButton(Taste_Vent, true);
  myButtons.disableButton(Taste_Stuetzen, true);
  myButtons.disableButton(Taste_Ok, true);
  myGLCD.clrScr(); 
  myGLCD.fillScr(0, 191,255);
   myButtons.enableButton(Taste_Aendern, true);   
 
  myButtons.enableButton(Taste_fertig, true);
  myButtons.enableButton(Taste_Anzeige, true);

  myButtons.enableButton(Taste_n_Funktion, true);
  myButtons.enableButton(Taste_Auto_rauf, true);
  myButtons.enableButton(Taste_Auto_runter, true);


myGLCD.setFont(SmallFont);myGLCD.setColor(VGA_BLACK);

while (abbruch==0)
  {
   Taste_gedrueckt = myButtons.checkButtons();
  if (Taste_gedrueckt == Taste_fertig) {abbruch=1;}
  if (Taste_gedrueckt == Taste_Anzeige) {abbruch=1;}
    
  if (Taste_gedrueckt == Taste_n_Funktion) {x++;if (x>13) x=0;}

  if (x==0) 
      {
      myGLCD.print("Funktion auswaehlen ", 50, 100);myGLCD.print("      ", 120, 120); 
      }

//--------------------------------------------------------------------------------
  if (x==1) // Eisfach
    {
    myGLCD.print("Warntemperatur Eisfach         ", 50, 100);
    myGLCD.print("      ", 120, 120);  
    myGLCD.printNumI(soll_EisTemp, 120, 120);   
    myGLCD.print("C", 150, 120);

    soll_EisTemp_alt=soll_EisTemp;
    if (Taste_gedrueckt==Taste_Aendern)
      {
      myButtons.disableButton(Taste_Aendern, true);  
      myButtons.enableButton(Taste_Ok, true);
      while (abbruch_ok==0)
        {
        Taste_gedrueckt = myButtons.checkButtons();
        if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
        if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
        if (Taste_gedrueckt == Taste_Auto_rauf) {soll_EisTemp++; if (soll_EisTemp>2) soll_EisTemp=2;}
        if (Taste_gedrueckt == Taste_Auto_runter) {soll_EisTemp--;if (soll_EisTemp<-20) soll_EisTemp=-20;} 
           
        if ( soll_EisTemp_alt!=soll_EisTemp)
          { 
          soll_EisTemp_alt=soll_EisTemp ;  
          myGLCD.print("      ", 120, 120);  
          myGLCD.printNumI(soll_EisTemp, 120, 120);  
          }   
        }
      if (abbruch_ok==1) EEPROM.update(10, soll_EisTemp);
      
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }

    abbruch_ok=0; 
    }
//--------------------------------------------------------------------------------
    if (x==2) // Kühlschrank
    {
    myGLCD.print("Warntemperatur Kuehlfach        ", 50, 100);
    myGLCD.print("      ", 120, 120); 
    myGLCD.printNumI(sollKtemp, 120, 120);   
    myGLCD.print("C", 150, 120);
    
    if (Taste_gedrueckt==Taste_Aendern)
      {
      sollKtemp_alt=sollKtemp;  
      myButtons.disableButton(Taste_Aendern, true);  
      myButtons.enableButton(Taste_Ok, true);
      while (abbruch_ok==0)
        {
        Taste_gedrueckt = myButtons.checkButtons();
        if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
        if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
        if (Taste_gedrueckt == Taste_Auto_rauf) {sollKtemp++;if (sollKtemp>10) sollKtemp=10;}
        if (Taste_gedrueckt == Taste_Auto_runter) {sollKtemp--;if (sollKtemp<0) sollKtemp=0;}
        if ( sollKtemp_alt!=sollKtemp)
          { 
          sollKtemp_alt=sollKtemp ;  
          myGLCD.print("      ", 120, 120);  
          myGLCD.printNumI(sollKtemp, 120, 120); 
          myGLCD.print("C", 150, 120); 
          }        
        }
      if (abbruch_ok==1) EEPROM.update(11, sollKtemp);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }

    abbruch_ok=0; 
    }
//--------------------------------------------------------------------------------
  if (x==3) // Kühlschranklüfter
    {
    myGLCD.print("Temperatur K-Luefter        ", 50, 100);
    myGLCD.print("      ", 120, 120); 
    myGLCD.printNumI(soll_k_luefter, 120, 120);   
    myGLCD.print("C", 150, 120);
    
    if (Taste_gedrueckt==Taste_Aendern)
      {
      soll_k_luefter_alt=soll_k_luefter;
      myButtons.disableButton(Taste_Aendern, true);  
      myButtons.enableButton(Taste_Ok, true);
      while (abbruch_ok==0)
        {
        Taste_gedrueckt = myButtons.checkButtons();
        if (Taste_gedrueckt == Taste_fertig){abbruch_ok=2;}
        if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
        if (Taste_gedrueckt == Taste_Auto_rauf) {soll_k_luefter++;if (soll_k_luefter>70) soll_k_luefter=70;}
        if (Taste_gedrueckt == Taste_Auto_runter) {soll_k_luefter--;if (soll_k_luefter<10) soll_k_luefter=10;} 
        if ( soll_k_luefter_alt!=soll_k_luefter)
          { 
          soll_k_luefter_alt=soll_k_luefter ;  
          myGLCD.print("      ", 120, 120);  
          myGLCD.printNumI(soll_k_luefter, 120, 120);
           myGLCD.print("C", 150, 120);  
          }              
        }
      if (abbruch_ok==1) EEPROM.update(12, soll_k_luefter);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }

    abbruch_ok=0; 
    }
//--------------------------------------------------------------------------------
  if (x==4) // Hystere Luefter
      {
    myGLCD.print("Hysterese K-Luefter        ", 50, 100);
    myGLCD.print("      ", 120, 120); 
    myGLCD.printNumI(soll_h_luefter, 120, 120);   
    myGLCD.print("C", 150, 120);
    
    if (Taste_gedrueckt==Taste_Aendern)
      {
      soll_h_luefter_alt=soll_h_luefter;
      myButtons.disableButton(Taste_Aendern, true);  
      myButtons.enableButton(Taste_Ok, true);
      while (abbruch_ok==0)
        {
        Taste_gedrueckt = myButtons.checkButtons();
        if (Taste_gedrueckt == Taste_fertig){abbruch_ok=2;}
        if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
        if (Taste_gedrueckt == Taste_Auto_rauf) {soll_h_luefter++;if (soll_h_luefter>20) soll_h_luefter=20;}
        if (Taste_gedrueckt == Taste_Auto_runter) {soll_h_luefter--;if (soll_h_luefter<1) soll_h_luefter=1;} 
        if ( soll_h_luefter_alt!=soll_h_luefter)
          { 
          soll_h_luefter_alt=soll_h_luefter ;  
          myGLCD.print("      ", 120, 120);  
          myGLCD.printNumI(soll_h_luefter, 120, 120);   
          myGLCD.print("C", 150, 120);
          }              
        }
      if (abbruch_ok==1) EEPROM.update(16, soll_h_luefter);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }

    abbruch_ok=0; 
    }
//--------------------------------------------------------------------------------
  if (x==5) // Blockierstrom
      {
      myGLCD.print("Blockierstrom             ", 50, 100);
      myGLCD.print("      ", 120, 120); 
      myGLCD.printNumI(soll_Strom_blockiert, 120, 120);
      myGLCD.print("A", 150, 120);
      
     if (Taste_gedrueckt==Taste_Aendern)
      {
      soll_Strom_blockiert_alt=soll_Strom_blockiert;
      myButtons.disableButton(Taste_Aendern, true);  
      myButtons.enableButton(Taste_Ok, true);
      while (abbruch_ok==0)
        {
        Taste_gedrueckt = myButtons.checkButtons();
        if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
        if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
        if (Taste_gedrueckt == Taste_Auto_rauf) {soll_Strom_blockiert++;if (soll_Strom_blockiert>10) soll_Strom_blockiert=10;}
        if (Taste_gedrueckt == Taste_Auto_runter) {soll_Strom_blockiert--;if (soll_Strom_blockiert<1) soll_Strom_blockiert=1;} 
        if ( soll_Strom_blockiert_alt!=soll_Strom_blockiert)
          { 
          soll_Strom_blockiert_alt=soll_Strom_blockiert ;  
          myGLCD.print("      ", 120, 120);  
          myGLCD.printNumI(soll_Strom_blockiert, 120, 120); 
          myGLCD.print("A", 150, 120); 
          }         
        }
      if (abbruch_ok==1) EEPROM.update(13, soll_Strom_blockiert);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }

    abbruch_ok=0; 
    }

//--------------------------------------------------------------------------------
  if (x==6) // Strom Endposition
      {
      myGLCD.print("Strom Endposition           ", 50, 100);
      myGLCD.print("      ", 120, 120); 
      myGLCD.printNumI(soll_Strom_Endposition, 120, 120);
      myGLCD.print("A", 150, 120);
      
      if (Taste_gedrueckt==Taste_Aendern)
      {
        soll_Strom_Endposition_alt=soll_Strom_Endposition;
      myButtons.disableButton(Taste_Aendern, true);  
      myButtons.enableButton(Taste_Ok, true);
      while (abbruch_ok==0)
        {
        Taste_gedrueckt = myButtons.checkButtons();
        if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
        if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
        if (Taste_gedrueckt == Taste_Auto_rauf) {soll_Strom_Endposition++;if (soll_Strom_Endposition>soll_Strom_blockiert-1) soll_Strom_Endposition=soll_Strom_blockiert-1;}
        if (Taste_gedrueckt == Taste_Auto_runter) {soll_Strom_Endposition--;if (soll_Strom_Endposition<soll_Strom_normal) soll_Strom_Endposition=soll_Strom_normal;}  
        if ( soll_Strom_Endposition_alt!=soll_Strom_Endposition)
          { 
          soll_Strom_Endposition_alt=soll_Strom_Endposition ;  
          myGLCD.print("      ", 120, 120);  
          myGLCD.printNumI(soll_Strom_Endposition, 120, 120);
          myGLCD.print("A", 150, 120);  
          }        
        }
      if (abbruch_ok==1) EEPROM.update(14, soll_Strom_Endposition);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }

    abbruch_ok=0; 
    }

//--------------------------------------------------------------------------------
    if (x==7) //Strom Normal 
      {
      myGLCD.print("Strom Normal           ", 50, 100);
      myGLCD.print("      ", 120, 120); 
      myGLCD.printNumI(soll_Strom_normal, 120, 120);
      myGLCD.print("A", 150, 120);
      
      if (Taste_gedrueckt==Taste_Aendern)
       {
        soll_Strom_normal_alt=soll_Strom_normal;
        myButtons.disableButton(Taste_Aendern, true);  
        myButtons.enableButton(Taste_Ok, true);
        while (abbruch_ok==0)
          {
          Taste_gedrueckt = myButtons.checkButtons();
          if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
          if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
          if (Taste_gedrueckt == Taste_Auto_rauf) {soll_Strom_normal++;if (soll_Strom_normal>soll_Strom_Endposition-1) soll_Strom_normal=soll_Strom_Endposition-1;}
          if (Taste_gedrueckt == Taste_Auto_runter) {soll_Strom_normal--;if (soll_Strom_normal<0) soll_Strom_normal=0;}        
          if ( soll_Strom_normal_alt!=soll_Strom_normal)
            { 
            soll_Strom_normal_alt=soll_Strom_normal ;  
            myGLCD.print("      ", 120, 120);  
            myGLCD.printNumI(soll_Strom_normal, 120, 120);
            myGLCD.print("A", 150, 120);  
            }      
          
          }
      if (abbruch_ok==1) EEPROM.update(15, soll_Strom_normal);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }

    abbruch_ok=0; 
    }
//--------------------------------------------------------------------------------
    if (x==8) //Solar vorhanden 
      {
      myGLCD.print("Solar vorhanden ?      ", 50, 100);
      myGLCD.print("      ", 120, 120); 
      if (soll_Solar==1) { myGLCD.print("Solar vorhanden      ", 100, 120);  }
      if (soll_Solar==0) { myGLCD.print("Solar nicht vorhanden", 100, 120);} 
           
      if (Taste_gedrueckt==Taste_Aendern)
       {
        soll_Strom_normal_alt=soll_Strom_normal;
        myButtons.disableButton(Taste_Aendern, true);  
        myButtons.enableButton(Taste_Ok, true);
        while (abbruch_ok==0)
          {
          Taste_gedrueckt = myButtons.checkButtons();
          if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
          if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
          if (Taste_gedrueckt == Taste_Auto_rauf) {soll_Solar=1;   myGLCD.print("Solar vorhanden      ", 100, 120);  }
          if (Taste_gedrueckt == Taste_Auto_runter) {soll_Solar=0;myGLCD.print("Solar nicht vorhanden", 100, 120);}        
          
          
          }
      if (abbruch_ok==1) EEPROM.update(18, soll_Solar);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
     
      }
    myGLCD.print("                     ", 100, 120);
    abbruch_ok=0; 
    }

//--------------------------------------------------------------------------------
   if (x==9) //Spannung kalibrierung
      {
      myGLCD.print("Spannung kalibrierung  ", 50, 100);
      myGLCD.print("      ", 120, 120); 

                 
      if (Taste_gedrueckt==Taste_Aendern)
       {
        soll_Strom_normal_alt=soll_Strom_normal;
        myButtons.disableButton(Taste_Aendern, true);  
        myButtons.enableButton(Taste_Ok, true);
        while (abbruch_ok==0)
          {
         
            
          Taste_gedrueckt = myButtons.checkButtons();
          if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
          if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
          if (Taste_gedrueckt == Taste_Auto_rauf) 
           {
            Spannung_Kalibrierung=Spannung_Kalibrierung+0.1;
            if (Spannung_Kalibrierung>0.5) Spannung_Kalibrierung= 0.5;            
           }
          if (Taste_gedrueckt == Taste_Auto_runter) 
            {
            Spannung_Kalibrierung=Spannung_Kalibrierung-0.1; 
            if (Spannung_Kalibrierung<-0.5) Spannung_Kalibrierung= -0.5;
            }        

           Spannung_Batterie= (analogRead(ADC_Batterie_Spannung)*285.0)/(10240.0)+ Spannung_Kalibrierung; //spannungsteiler 47k/10k
           
           dtostrf( Spannung_Batterie, 5, 1, buffer );     
           myGLCD.print(buffer, 100, 120);
           myGLCD.print("V", 150, 120);
         
           dtostrf( Spannung_Kalibrierung, 5, 1, buffer );    
           myGLCD.print(buffer, 100, 130);
           myGLCD.print("V", 140, 130);
          
          
          }
      if (abbruch_ok==1) EEPROM.update(17, (unsigned char)(Spannung_Kalibrierung*10+50));
      myGLCD.print("                  ", 100, 130);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
     
      }
    myGLCD.print("                     ", 100, 120);
    abbruch_ok=0; 
    }


//--------------------------------------------------------------------------------
    if (x==10) //Batterietyp 
      {
      myGLCD.print("Batterietyp ?      ", 50, 100);
      myGLCD.print("      ", 120, 120); 
      if (Batterietyp==Batterie_Blei)     { myGLCD.print("Blei                 ", 100, 120);  }
      if (Batterietyp==Batterie_LiFePo4)  { myGLCD.print("LiFePo4              ", 100, 120);} 
           
      if (Taste_gedrueckt==Taste_Aendern)
       {

        myButtons.disableButton(Taste_Aendern, true);  
        myButtons.enableButton(Taste_Ok, true);
        while (abbruch_ok==0)
          {
          Taste_gedrueckt = myButtons.checkButtons();
          if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
          if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
          if (Taste_gedrueckt == Taste_Auto_rauf) {Batterietyp=Batterie_Blei;   myGLCD.print("Blei                 ", 100, 120);  }
          if (Taste_gedrueckt == Taste_Auto_runter) {Batterietyp=Batterie_LiFePo4;myGLCD.print("LiFePo4              ", 100, 120);}        
          
          
          }
      if (abbruch_ok==1) EEPROM.update(19, Batterietyp);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
     
      }
    myGLCD.print("                     ", 100, 120);
    abbruch_ok=0; 
    }
//--------------------------------------------------------------------------------
    if (x==11) //Endschalter vorhanden
      {
      myGLCD.print("Endschalter ?      ", 50, 100);
      myGLCD.print("      ", 120, 120); 
      if (Endschalter==Endschalter_vorhanden)  { myGLCD.print("vorhanden            ", 100, 120);  }
      if (Endschalter==Endschalter_nicht_vorhanden)  { myGLCD.print("nicht vorhanden      ", 100, 120);} 
           
      if (Taste_gedrueckt==Taste_Aendern)
       {

        myButtons.disableButton(Taste_Aendern, true);  
        myButtons.enableButton(Taste_Ok, true);
        while (abbruch_ok==0)
          {
          Taste_gedrueckt = myButtons.checkButtons();
          if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
          if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
          if (Taste_gedrueckt == Taste_Auto_rauf) {Endschalter=Endschalter_vorhanden;   myGLCD.print("vorhanden            ", 100, 120);  }
          if (Taste_gedrueckt == Taste_Auto_runter) {Endschalter=Endschalter_nicht_vorhanden;myGLCD.print("nicht vorhanden      ", 100, 120);}        
          
          
          }
      if (abbruch_ok==1) EEPROM.update(20, Endschalter);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
     
      }
    myGLCD.print("                     ", 100, 120);
    abbruch_ok=0; 
    }

  //--------------------------------------------------------------------------------
    if (x==12) //Timeout Endpostion
    {
      myGLCD.print("Time Endposition   ", 50, 100);
      myGLCD.print("      ", 120, 120); 
      myGLCD.printNumI(soll_Timeout_Endpostion, 120, 120);
      myGLCD.print("x100ms", 150, 120);
      
      if (Taste_gedrueckt==Taste_Aendern)
       {
        soll_Timeout_Endpostion_alt=soll_Timeout_Endpostion;
        myButtons.disableButton(Taste_Aendern, true);  
        myButtons.enableButton(Taste_Ok, true);
        while (abbruch_ok==0)
          {
          Taste_gedrueckt = myButtons.checkButtons();
          if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
          if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
          if (Taste_gedrueckt == Taste_Auto_rauf) {soll_Timeout_Endpostion++;if (soll_Timeout_Endpostion>10) soll_Timeout_Endpostion=10;}
          if (Taste_gedrueckt == Taste_Auto_runter) {soll_Timeout_Endpostion--;if (soll_Timeout_Endpostion<0) soll_Timeout_Endpostion=0;}        
          if (soll_Timeout_Endpostion_alt!=soll_Timeout_Endpostion)
            { 
            soll_Timeout_Endpostion_alt=soll_Timeout_Endpostion ;  
            myGLCD.print("      ", 120, 120);  
            myGLCD.printNumI(soll_Timeout_Endpostion, 120, 120);
            myGLCD.print("x100ms", 150, 120);  
            }      
          
          }
      if (abbruch_ok==1) EEPROM.update(21, soll_Timeout_Endpostion);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }
	myGLCD.print("                     ", 100, 120);
    abbruch_ok=0; 
    }  
	
	if (x==13) //Wert Wasserstandserkennung
    {
      myGLCD.print("Wert Wasserstand   ", 50, 100);
      myGLCD.print("      ", 120, 120); 
      myGLCD.printNumI((soll_Wasserstand*10), 120, 120);
            
	  pinMode(A8,INPUT_PULLUP);pinMode(A9,INPUT_PULLUP);pinMode(A10,INPUT_PULLUP);pinMode(A11,INPUT_PULLUP);
 
	  
      if (Taste_gedrueckt==Taste_Aendern)
       {
        soll_Wasserstand_alt=soll_Wasserstand;
        myButtons.disableButton(Taste_Aendern, true);  
        myButtons.enableButton(Taste_Ok, true);
        while (abbruch_ok==0)
          {
			temp_wasser0=analogRead(A11);
			temp_wasser1=analogRead(A10);
			temp_wasser2=analogRead(A9);
			temp_wasser3=analogRead(A8);  
			  
			myGLCD.printNumI((temp_wasser0), 50, 120); 
			myGLCD.printNumI((temp_wasser1), 50, 130); 
			myGLCD.printNumI((temp_wasser2), 50, 140); 
			myGLCD.printNumI((temp_wasser3), 50, 150); 
			  
			  
          Taste_gedrueckt = myButtons.checkButtons();
          if (Taste_gedrueckt == Taste_fertig) {abbruch_ok=2;}
          if (Taste_gedrueckt == Taste_Ok) {abbruch_ok=1;}
          if (Taste_gedrueckt == Taste_Auto_rauf) {soll_Wasserstand++;if (soll_Wasserstand>100) soll_Wasserstand=100;}
          if (Taste_gedrueckt == Taste_Auto_runter) {soll_Wasserstand--;if (soll_Wasserstand<0) soll_Wasserstand=0;}        
          if (soll_Wasserstand_alt!=soll_Wasserstand)
            { 
            soll_Wasserstand_alt=soll_Wasserstand ;  
            myGLCD.print("      ", 120, 120);  
            myGLCD.printNumI((soll_Wasserstand*10), 120, 120);
       
            }      
          
          }
      if (abbruch_ok==1) EEPROM.update(22, soll_Wasserstand);
      myButtons.disableButton(Taste_Ok, true);
      myButtons.enableButton(Taste_Aendern, true);  
      }
	myGLCD.print("                     ", 100, 120);

	pinMode(A8,INPUT);pinMode(A9,INPUT);pinMode(A10,INPUT);pinMode(A11,INPUT); // pullup ausschalten
	myGLCD.print("    ", 50, 120);
	myGLCD.print("    ", 50, 130);
	myGLCD.print("    ", 50, 140);
	myGLCD.print("    ", 50, 150);
 
    abbruch_ok=0; 
    
	}  
  } // ende while abbruch


Case=Case_Anzeige;
  
}

//======================================================================================================
//====================================    Hauptprogramm       ==========================================
//======================================================================================================


void loop()
{
  Motor_li_vo_stopp;Motor_re_vo_stopp;Motor_li_hi_stopp;Motor_re_hi_stopp;
 
if (Case==Case_stuetzen) Stuetzen();
if (Case==Case_Anzeige) Anzeige();  
if (Case==Case_einstell) Einstellungen();  



}// ende loop




